## lowdown 1.1.0

=== Makefile ===
.PHONY: regress regen_regress
.SUFFIXES: .xml .md .html .pdf .1 .1.html .3 .3.html .5 .5.html .thumb.jpg .png .in.pc .pc .valgrind .old.md .diff-valgrind

include Makefile.configure

# Follows semver.
# This is complex because lowdown is both a program and a library; and
# while libraries have well-defined semantics of semver change, programs
# do not.  Let the library guide our versioning until a better way is
# thought out.
VERSION		 = 1.1.0
# This is the major number of VERSION.  It might later become
# MAJOR.MINOR, if the library moves a lot.
LIBVER		 = 1
OBJS		 = autolink.o \
		   buffer.o \
		   diff.o \
		   document.o \
		   entity.o \
		   gemini.o \
		   html.o \
		   html_escape.o \
		   latex.o \
		   library.o \
		   libdiff.o \
		   nroff.o \
		   odt.o \
		   smartypants.o \
		   term.o \
		   tree.o \
		   util.o
COMPAT_OBJS	 = compats.o
WWWDIR		 = /var/www/vhosts/kristaps.bsd.lv/htdocs/lowdown
HTMLS		 = archive.html \
		   atom.xml \
		   diff.html \
		   diff.diff.html \
		   index.html \
		   README.html \
		   $(MANS)
MANS		 = $(MAN1S) $(MAN3S) $(MAN5S)
MAN1S		 = man/lowdown.1.html \
		   man/lowdown-diff.1.html
MAN5S =  	   man/lowdown.5.html
MAN3S = 	   man/lowdown.3.html \
		   man/lowdown_buf.3.html \
		   man/lowdown_buf_diff.3.html \
		   man/lowdown_buf_free.3.html \
		   man/lowdown_buf_new.3.html \
		   man/lowdown_diff.3.html \
		   man/lowdown_doc_free.3.html \
		   man/lowdown_doc_new.3.html \
		   man/lowdown_doc_parse.3.html \
		   man/lowdown_file.3.html \
		   man/lowdown_file_diff.3.html \
		   man/lowdown_gemini_free.3.html \
		   man/lowdown_gemini_new.3.html \
		   man/lowdown_gemini_rndr.3.html \
		   man/lowdown_html_free.3.html \
		   man/lowdown_html_new.3.html \
		   man/lowdown_html_rndr.3.html \
		   man/lowdown_latex_free.3.html \
		   man/lowdown_latex_new.3.html \
		   man/lowdown_latex_rndr.3.html \
		   man/lowdown_metaq_free.3.html \
		   man/lowdown_node_free.3.html \
		   man/lowdown_nroff_free.3.html \
		   man/lowdown_nroff_new.3.html \
		   man/lowdown_nroff_rndr.3.html \
		   man/lowdown_odt_free.3.html \
		   man/lowdown_odt_new.3.html \
		   man/lowdown_odt_rndr.3.html \
		   man/lowdown_term_free.3.html \
		   man/lowdown_term_new.3.html \
		   man/lowdown_term_rndr.3.html \
		   man/lowdown_tree_rndr.3.html
SOURCES		 = autolink.c \
		   buffer.c \
		   compats.c \
		   diff.c \
		   document.c \
		   entity.c \
		   gemini.c \
		   html.c \
		   html_escape.c \
		   latex.c \
		   libdiff.c \
		   library.c \
		   main.c \
		   nroff.c \
		   odt.c \
		   smartypants.c \
		   term.c \
		   tests.c \
		   tree.c \
		   util.c
HEADERS 	 = extern.h \
		   libdiff.h \
		   lowdown.h \
		   term.h
PDFS		 = diff.pdf \
		   diff.diff.pdf \
		   index.latex.pdf \
		   index.mandoc.pdf \
		   index.nroff.pdf
MDS		 = index.md README.md
CSSS		 = diff.css template.css
JSS		 = diff.js
IMAGES		 = screen-mandoc.png \
		   screen-groff.png \
		   screen-term.png
THUMBS		 = screen-mandoc.thumb.jpg \
		   screen-groff.thumb.jpg \
		   screen-term.thumb.jpg
VALGRINDS	!= for f in `find regress -name \*.md` ; do echo `dirname $$f`/`basename $$f .md`.valgrind ; done
VALGRINDDIFFS	!= for f in `find regress/diff -name \*.old.md` ; do echo `dirname $$f`/`basename $$f .old.md`.diff-valgrind ; done
# Because the objects will be compiled into a shared library:
CFLAGS		+= -fPIC
# To avoid exporting internal functions (lowdown.h has default visibility).
CFLAGS		+= -fvisibility=hidden

# Only for MarkdownTestv1.0.3 in regress/original.

REGRESS_ARGS	 = "--out-no-smarty"
REGRESS_ARGS	+= "--parse-no-img-ext"
REGRESS_ARGS	+= "--parse-no-metadata"
REGRESS_ARGS	+= "--parse-super-short"
REGRESS_ARGS	+= "--html-no-head-ids"
REGRESS_ARGS	+= "--html-no-skiphtml"
REGRESS_ARGS	+= "--html-no-escapehtml"
REGRESS_ARGS	+= "--html-no-owasp"
REGRESS_ARGS	+= "--html-no-num-ent"
REGRESS_ARGS	+= "--parse-no-autolink"
REGRESS_ARGS	+= "--parse-no-cmark"
REGRESS_ARGS	+= "--parse-no-deflists"

VALGRIND_ARGS	 = -q --leak-check=full --leak-resolution=high --show-reachable=yes

all: bins lowdown.pc liblowdown.so
bins: lowdown lowdown-diff

valgrind: $(VALGRINDS) $(VALGRINDDIFFS)
	@for f in $(VALGRINDS) ; do \
		if [ -s $$f ]; then \
			echo `dirname $$f`/`basename $$f .valgrind`.md ; \
			cat $$f ; \
		fi ; \
	done
	@for f in $(VALGRINDDIFFS) ; do \
		if [ -s $$f ]; then \
			echo `dirname $$f`/`basename $$f .diff-valgrind`.old.md ; \
			cat $$f ; \
		fi ; \
	done

$(VALGRINDS) $(VALGRINDDIFFS): bins

.old.md.diff-valgrind:
	@rm -f $@
	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tfodt $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -thtml $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tms $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tman $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tterm $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tgemini $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@

.md.valgrind:
	@rm -f $@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -tfodt $< >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -thtml $< >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -tms $< >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -tman $< >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -tterm $< >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -tgemini $< >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -tlatex $< >/dev/null 2>>$@

www: all $(HTMLS) $(PDFS) $(THUMBS) lowdown.tar.gz lowdown.tar.gz.sha512

installwww: www
	mkdir -p $(WWWDIR)/snapshots
	$(INSTALL) -m 0444 $(THUMBS) $(IMAGES) $(MDS) $(HTMLS) $(CSSS) $(JSS) $(PDFS) $(WWWDIR)
	$(INSTALL) -m 0444 lowdown.tar.gz $(WWWDIR)/snapshots/lowdown-$(VERSION).tar.gz
	$(INSTALL) -m 0444 lowdown.tar.gz.sha512 $(WWWDIR)/snapshots/lowdown-$(VERSION).tar.gz.sha512
	$(INSTALL) -m 0444 lowdown.tar.gz $(WWWDIR)/snapshots
	$(INSTALL) -m 0444 lowdown.tar.gz.sha512 $(WWWDIR)/snapshots

lowdown: liblowdown.a main.o
	$(CC) -o $@ main.o liblowdown.a $(LDFLAGS) $(LDADD_MD5) -lm $(LDADD)

lowdown-diff: lowdown
	ln -f lowdown lowdown-diff

liblowdown.a: $(OBJS) $(COMPAT_OBJS)
	$(AR) rs $@ $(OBJS) $(COMPAT_OBJS)

liblowdown.so: $(OBJS) $(COMPAT_OBJS)
	$(CC) -shared -o $@.$(LIBVER) $(OBJS) $(COMPAT_OBJS) $(LDFLAGS) $(LDADD_MD5) -lm -Wl,${LINKER_SONAME},$@.$(LIBVER) $(LDLIBS)
	ln -sf $@.$(LIBVER) $@

uninstall:
	rm -rf $(SHAREDIR)/lowdown
	rm -f $(BINDIR)/lowdown $(BINDIR)/lowdown-diff
	for f in $(MAN1S) $(MAN5S) ; do \
		name=`basename $$f .html` ; \
		section=$${name##*.} ; \
		rm -f $(MANDIR)/man$$section/$$name ; \
	done

install: bins
	mkdir -p $(DESTDIR)$(BINDIR)
	mkdir -p $(DESTDIR)$(MANDIR)/man1
	mkdir -p $(DESTDIR)$(MANDIR)/man5
	mkdir -p $(DESTDIR)$(SHAREDIR)/lowdown/odt
	$(INSTALL_DATA) share/odt/styles.xml $(DESTDIR)$(SHAREDIR)/lowdown/odt
	$(INSTALL_PROGRAM) lowdown $(DESTDIR)$(BINDIR)
	$(INSTALL_PROGRAM) lowdown-diff $(DESTDIR)$(BINDIR)
	for f in $(MAN1S) $(MAN5S) ; do \
		name=`basename $$f .html` ; \
		section=$${name##*.} ; \
		$(INSTALL_MAN) man/$$name $(DESTDIR)$(MANDIR)/man$$section ; \
	done

uninstall_lib_common:
	rm -f $(LIBDIR)/pkgconfig/lowdown.pc
	rm -f $(INCLUDEDIR)/lowdown.h
	for f in $(MAN3S) ; do \
		name=`basename $$f .html` ; \
		section=$${name##*.} ; \
		rm -f $(MANDIR)/man$$section/$$name ; \
	done

install_lib_common: lowdown.pc
	mkdir -p $(DESTDIR)$(MANDIR)/man3
	mkdir -p $(DESTDIR)$(LIBDIR)/pkgconfig
	mkdir -p $(DESTDIR)$(INCLUDEDIR)
	$(INSTALL_DATA) lowdown.pc $(DESTDIR)$(LIBDIR)/pkgconfig
	$(INSTALL_DATA) lowdown.h $(DESTDIR)$(INCLUDEDIR)
	for f in $(MAN3S) ; do \
		name=`basename $$f .html` ; \
		section=$${name##*.} ; \
		$(INSTALL_MAN) man/$$name $(DESTDIR)$(MANDIR)/man$$section ; \
	done

uninstall_shared: uninstall_lib_common
	rm -f $(LIBDIR)/liblowdown.so.$(LIBVER) $(LIBDIR)/liblowdown.so

install_shared: liblowdown.so install_lib_common
	$(INSTALL_LIB) liblowdown.so.$(LIBVER) $(DESTDIR)$(LIBDIR)
	( cd $(DESTDIR)$(LIBDIR) && ln -sf liblowdown.so.$(LIBVER) liblowdown.so )

uninstall_static: uninstall_lib_common
	rm -f $(LIBDIR)/liblowdown.a

install_static: liblowdown.a install_lib_common
	$(INSTALL_LIB) liblowdown.a $(DESTDIR)$(LIBDIR)

uninstall_libs: uninstall_shared uninstall_static

install_libs: install_shared install_static

distcheck: lowdown.tar.gz.sha512
	mandoc -Tlint -Werror man/*.[135]
	newest=`grep "<h1>" versions.xml | tail -1 | sed 's![ 	]*!!g'` ; \
	       [ "$$newest" = "<h1>$(VERSION)</h1>" ] || \
		{ echo "Version $(VERSION) not newest in versions.xml" 1>&2 ; exit 1 ; }
	[ "`openssl dgst -sha512 -hex lowdown.tar.gz`" = "`cat lowdown.tar.gz.sha512`" ] || \
		{ echo "Checksum does not match." 1>&2 ; exit 1 ; }
	rm -rf .distcheck
	mkdir -p .distcheck
	( cd .distcheck && tar -zvxpf ../lowdown.tar.gz )
	( cd .distcheck/lowdown-$(VERSION) && ./configure PREFIX=prefix )
	( cd .distcheck/lowdown-$(VERSION) && $(MAKE) )
	( cd .distcheck/lowdown-$(VERSION) && $(MAKE) regress )
	( cd .distcheck/lowdown-$(VERSION) && $(MAKE) install )
	rm -rf .distcheck

$(PDFS) index.xml README.xml: lowdown

index.html README.html: template.xml

.md.pdf:
	./lowdown --nroff-no-numbered -s -tms $< | \
		pdfroff -i -mspdf -t -k > $@

index.latex.pdf: index.md $(THUMBS)
	./lowdown -s -tlatex index.md >index.latex.latex
	pdflatex index.latex.latex
	pdflatex index.latex.latex

index.mandoc.pdf: index.md
	./lowdown --nroff-no-numbered -s -tman index.md | \
		mandoc -Tpdf > $@

index.nroff.pdf: index.md
	./lowdown --nroff-no-numbered -s -tms index.md | \
		pdfroff -i -mspdf -t -k > $@

.xml.html:
	sblg -t template.xml -s date -o $@ -C $< $< versions.xml

archive.html: archive.xml versions.xml
	sblg -t archive.xml -s date -o $@ versions.xml

atom.xml: atom-template.xml versions.xml
	sblg -a -t atom-template.xml -s date -o $@ versions.xml

diff.html: diff.md lowdown
	./lowdown -s diff.md >$@

diff.diff.html: diff.md diff.old.md lowdown-diff
	./lowdown-diff -s diff.old.md diff.md >$@

diff.diff.pdf: diff.md diff.old.md lowdown-diff
	./lowdown-diff --nroff-no-numbered -s -tms diff.old.md diff.md | \
		pdfroff -i -mspdf -t -k > $@

$(HTMLS): versions.xml lowdown

.md.xml: lowdown
	( echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" ; \
	  echo "<article data-sblg-article=\"1\">" ; \
	  ./lowdown $< ; \
	  echo "</article>" ; ) >$@

.1.1.html .3.3.html .5.5.html:
	mandoc -Thtml -Ostyle=https://bsd.lv/css/mandoc.css $< >$@

lowdown.tar.gz.sha512: lowdown.tar.gz
	openssl dgst -sha512 -hex lowdown.tar.gz >$@

lowdown.tar.gz:
	mkdir -p .dist/lowdown-$(VERSION)/
	mkdir -p .dist/lowdown-$(VERSION)/man
	mkdir -p .dist/lowdown-$(VERSION)/share/odt
	mkdir -p .dist/lowdown-$(VERSION)/regress/original
	mkdir -p .dist/lowdown-$(VERSION)/regress/standalone
	mkdir -p .dist/lowdown-$(VERSION)/regress/metadata
	mkdir -p .dist/lowdown-$(VERSION)/regress/diff
	$(INSTALL) -m 0644 $(HEADERS) .dist/lowdown-$(VERSION)
	$(INSTALL) -m 0644 $(SOURCES) .dist/lowdown-$(VERSION)
	$(INSTALL) -m 0644 share/odt/* .dist/lowdown-$(VERSION)/share/odt
	$(INSTALL) -m 0644 lowdown.in.pc Makefile LICENSE.md .dist/lowdown-$(VERSION)
	$(INSTALL) -m 0644 man/*.1 man/*.3 man/*.5 .dist/lowdown-$(VERSION)/man
	$(INSTALL) -m 0755 configure .dist/lowdown-$(VERSION)
	$(INSTALL) -m 644 regress/original/* .dist/lowdown-$(VERSION)/regress/original
	$(INSTALL) -m 644 regress/*.* .dist/lowdown-$(VERSION)/regress
	$(INSTALL) -m 644 regress/standalone/* .dist/lowdown-$(VERSION)/regress/standalone
	$(INSTALL) -m 644 regress/metadata/* .dist/lowdown-$(VERSION)/regress/metadata
	$(INSTALL) -m 644 regress/diff/* .dist/lowdown-$(VERSION)/regress/diff
	( cd .dist/ && tar zcf ../$@ lowdown-$(VERSION) )
	rm -rf .dist/

$(OBJS) $(COMPAT_OBJS) main.o: config.h

$(OBJS): extern.h lowdown.h

term.o: term.h

=== debian/changelog ===
lowdown (1.1.0-2) unstable; urgency=medium

  * Use cross tools as set from buildtools.mk, to fix a FTCBFS. Thanks to
    Helmut Grohne for the report and patch. (Closes: #1066908)
  * Drop alternative dependency pkg-config, as it was already a transitional
    package in bookworm.
  * Remove liblowdown.map version script, as it is now unnecessary: upstream
    started using -fvisibility=hidden and #pragmas to limit symbol visibility.

 -- Faidon Liambotis <paravoid@debian.org>  Sat, 16 Mar 2024 14:33:12 +0200

lowdown (1.1.0-1) unstable; urgency=medium

  * New upstream release.
    - Drop previously backported upstream patches related to the roff
      constant-width problem.
    - Drop patch "revet-soname", upstream has now reverted LIBVER to 1.

 -- Faidon Liambotis <paravoid@debian.org>  Wed, 08 Nov 2023 08:33:19 +0200

=== debian/control ===
Source: lowdown
Priority: optional
Maintainer: Faidon Liambotis <paravoid@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libbsd-dev,
 libmd-dev,
 pkgconf,
Standards-Version: 4.6.2
Section: text
Homepage: https://kristaps.bsd.lv/lowdown/
Vcs-Browser: https://salsa.debian.org/debian/lowdown
Vcs-Git: https://salsa.debian.org/debian/lowdown.git
Rules-Requires-Root: no

Package: lowdown
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Simple markdown translator
 Lowdown is a Markdown translator producing HTML5, roff documents in the ms and
 man formats, LaTeX, gemini, and terminal output.
 .
 Beyond traditional Markdown syntax support, lowdown supports the following
 Markdown features and extensions:
  * autolinking
  * fenced code
  * tables
  * superscripts
  * footnotes
  * disabled inline HTML
  * “smart typography”
  * metadata
  * commonmark (in progress)
  * definition lists
  * extended attributes
  * task lists

Package: liblowdown-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblowdown1 (= ${binary:Version}), ${misc:Depends}
Description: Simple markdown translator (development files)
 Lowdown is a Markdown translator producing HTML5, roff documents in the ms and
 man formats, LaTeX, gemini, and terminal output.
 .
 Beyond traditional Markdown syntax support, lowdown supports the following
 Markdown features and extensions:
  * autolinking
  * fenced code
  * tables
  * superscripts
  * footnotes
  * disabled inline HTML
  * “smart typography”
  * metadata
  * commonmark (in progress)
  * definition lists
  * extended attributes
  * task lists
 .
 This package contains development libraries, header files, and manpages.

Package: liblowdown1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Simple markdown translator (shared library)
 Lowdown is a Markdown translator producing HTML5, roff documents in the ms and
 man formats, LaTeX, gemini, and terminal output.
 .
 Beyond traditional Markdown syntax support, lowdown supports the following
 Markdown features and extensions:
  * autolinking
  * fenced code
  * tables
  * superscripts
  * footnotes
  * disabled inline HTML
  * “smart typography”
  * metadata
  * commonmark (in progress)
  * definition lists
  * extended attributes
  * task lists
 .
 This package contains the shared runtime library.

## lowdown 1.1.1

=== debian/changelog ===
lowdown (1.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Faidon Liambotis <paravoid@debian.org>  Wed, 25 Sep 2024 17:28:22 +0300

## lowdown 1.1.2

=== Makefile ===
--- 
+++ 
@@ -2,13 +2,15 @@
 .SUFFIXES: .xml .md .html .pdf .1 .1.html .3 .3.html .5 .5.html .thumb.jpg .png .in.pc .pc .valgrind .old.md .diff-valgrind
 
 include Makefile.configure
+WWWDIR		 = /var/www/vhosts/kristaps.bsd.lv/htdocs/lowdown
+sinclude Makefile.local
 
 # Follows semver.
 # This is complex because lowdown is both a program and a library; and
 # while libraries have well-defined semantics of semver change, programs
 # do not.  Let the library guide our versioning until a better way is
 # thought out.
-VERSION		 = 1.1.0
+VERSION		 = 1.1.2
 # This is the major number of VERSION.  It might later become
 # MAJOR.MINOR, if the library moves a lot.
 LIBVER		 = 1
@@ -30,7 +32,6 @@
 		   tree.o \
 		   util.o
 COMPAT_OBJS	 = compats.o
-WWWDIR		 = /var/www/vhosts/kristaps.bsd.lv/htdocs/lowdown
 HTMLS		 = archive.html \
 		   atom.xml \
 		   diff.html \
@@ -140,18 +141,22 @@
 bins: lowdown lowdown-diff
 
 valgrind: $(VALGRINDS) $(VALGRINDDIFFS)
-	@for f in $(VALGRINDS) ; do \
+	@exit=0 ; \
+	for f in $(VALGRINDS) ; do \
 		if [ -s $$f ]; then \
 			echo `dirname $$f`/`basename $$f .valgrind`.md ; \
 			cat $$f ; \
+			exit=1 ; \
 		fi ; \
-	done
-	@for f in $(VALGRINDDIFFS) ; do \
+	done ; \
+	for f in $(VALGRINDDIFFS) ; do \
 		if [ -s $$f ]; then \
 			echo `dirname $$f`/`basename $$f .diff-valgrind`.old.md ; \
 			cat $$f ; \
+			exit=1 ; \
 		fi ; \
-	done
+	done ; \
+	exit $$exit
 
 $(VALGRINDS) $(VALGRINDDIFFS): bins
 
@@ -322,6 +327,14 @@
 	  ./lowdown $< ; \
 	  echo "</article>" ; ) >$@
 
+index.xml: index.md coverage.md coverage-table.md lowdown
+	( echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" ; \
+	  echo "<article data-sblg-article=\"1\">" ; \
+	  ./lowdown index.md ; \
+	  ./lowdown coverage.md ; \
+	  ./lowdown coverage-table.md ; \
+	  echo "</article>" ; ) >$@
+
 .1.1.html .3.3.html .5.5.html:
 	mandoc -Thtml -Ostyle=https://bsd.lv/css/mandoc.css $< >$@
 
@@ -332,6 +345,7 @@
 	mkdir -p .dist/lowdown-$(VERSION)/
 	mkdir -p .dist/lowdown-$(VERSION)/man
 	mkdir -p .dist/lowdown-$(VERSION)/share/odt
+	mkdir -p .dist/lowdown-$(VERSION)/regress/html
 	mkdir -p .dist/lowdown-$(VERSION)/regress/original
 	mkdir -p .dist/lowdown-$(VERSION)/regress/standalone
 	mkdir -p .dist/lowdown-$(VERSION)/regress/metadata
@@ -343,16 +357,3 @@
 	$(INSTALL) -m 0644 man/*.1 man/*.3 man/*.5 .dist/lowdown-$(VERSION)/man
 	$(INSTALL) -m 0755 configure .dist/lowdown-$(VERSION)
 	$(INSTALL) -m 644 regress/original/* .dist/lowdown-$(VERSION)/regress/original
-	$(INSTALL) -m 644 regress/*.* .dist/lowdown-$(VERSION)/regress
-	$(INSTALL) -m 644 regress/standalone/* .dist/lowdown-$(VERSION)/regress/standalone
-	$(INSTALL) -m 644 regress/metadata/* .dist/lowdown-$(VERSION)/regress/metadata
-	$(INSTALL) -m 644 regress/diff/* .dist/lowdown-$(VERSION)/regress/diff
-	( cd .dist/ && tar zcf ../$@ lowdown-$(VERSION) )
-	rm -rf .dist/
-
-$(OBJS) $(COMPAT_OBJS) main.o: config.h
-
-$(OBJS): extern.h lowdown.h
-
-term.o: term.h
-

=== debian/changelog ===
lowdown (1.1.2-1) unstable; urgency=medium

  * New upstream release.

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 04 Oct 2024 20:46:13 +0300

## lowdown 1.2.0

=== Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 # while libraries have well-defined semantics of semver change, programs
 # do not.  Let the library guide our versioning until a better way is
 # thought out.
-VERSION		 = 1.1.2
+VERSION		 = 1.2.0
 # This is the major number of VERSION.  It might later become
 # MAJOR.MINOR, if the library moves a lot.
 LIBVER		 = 1
@@ -330,9 +330,7 @@
 index.xml: index.md coverage.md coverage-table.md lowdown
 	( echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" ; \
 	  echo "<article data-sblg-article=\"1\">" ; \
-	  ./lowdown index.md ; \
-	  ./lowdown coverage.md ; \
-	  ./lowdown coverage-table.md ; \
+	  cat index.md coverage.md coverage-table.md | ./lowdown ; \
 	  echo "</article>" ; ) >$@
 
 .1.1.html .3.3.html .5.5.html:
@@ -357,3 +355,4 @@
 	$(INSTALL) -m 0644 man/*.1 man/*.3 man/*.5 .dist/lowdown-$(VERSION)/man
 	$(INSTALL) -m 0755 configure .dist/lowdown-$(VERSION)
 	$(INSTALL) -m 644 regress/original/* .dist/lowdown-$(VERSION)/regress/original
+	$(INSTALL) -m 644 regress/*.* .dist/lowdown-$(VERSION)/regress

=== debian/changelog ===
lowdown (1.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Faidon Liambotis <paravoid@debian.org>  Sat, 26 Oct 2024 01:40:19 +0300

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  libbsd-dev,
  libmd-dev,
  pkgconf,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: text
 Homepage: https://kristaps.bsd.lv/lowdown/
 Vcs-Browser: https://salsa.debian.org/debian/lowdown

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildtools.mk

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Use libbsd for a system copy of the BSD functions, instead of upstream's
# embedded compats.c coming from the oconfigure project.
# Also see https://github.com/kristapsdz/oconfigure/issues/19
CFLAGS += $(shell $(PKG_CONFIG) --cflags libmd libbsd-overlay)
LDFLAGS += $(shell $(PKG_CONFIG) --libs libmd libbsd-overlay)

%:
	dh $@ --buildsystem=makefile

override_dh_auto_configure:
	AR="$(AR)" \
	CC="$(CC)" \
	CFLAGS="${CFLAGS}" \
	./configure \
		PREFIX=/usr \
		MANDIR="/usr/share/man" \
		LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH} \
		CPPFLAGS="${CPPFLAGS}" \
		LDFLAGS="${LDFLAGS}"

override_dh_auto_install:
	# make install only installs the main binary, not the library
	make install DESTDIR=debian/tmp
	make install_static DESTDIR=debian/tmp
	make install_shared DESTDIR=debian/tmp

override_dh_auto_test:
	make regress

override_dh_auto_clean:
	echo > Makefile.configure
	dh_auto_clean

## lowdown 2.0.2

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
-.PHONY: regress regen_regress
-.SUFFIXES: .xml .md .html .pdf .1 .1.html .3 .3.html .5 .5.html .thumb.jpg .png .in.pc .pc .valgrind .old.md .diff-valgrind
+.PHONY: regress regen_regress valgrind
+.SUFFIXES: .xml .md .html .pdf .1 .1.html .3 .3.html .5 .5.html .thumb.jpg .png .in.pc .pc .old.md
 
 include Makefile.configure
 WWWDIR		 = /var/www/vhosts/kristaps.bsd.lv/htdocs/lowdown
@@ -10,24 +10,28 @@
 # while libraries have well-defined semantics of semver change, programs
 # do not.  Let the library guide our versioning until a better way is
 # thought out.
-VERSION		 = 1.2.0
+VERSION		 = 2.0.2
 # This is the major number of VERSION.  It might later become
 # MAJOR.MINOR, if the library moves a lot.
-LIBVER		 = 1
+LIBVER		 = 2
 OBJS		 = autolink.o \
 		   buffer.o \
 		   diff.o \
 		   document.o \
 		   entity.o \
 		   gemini.o \
+		   gemini_escape.o \
 		   html.o \
 		   html_escape.o \
 		   latex.o \
+		   latex_escape.o \
 		   library.o \
 		   libdiff.o \
 		   nroff.o \
+		   nroff_escape.o \
 		   odt.o \
 		   smartypants.o \
+		   template.o \
 		   term.o \
 		   tree.o \
 		   util.o
@@ -82,15 +86,19 @@
 		   document.c \
 		   entity.c \
 		   gemini.c \
+		   gemini_escape.c \
 		   html.c \
 		   html_escape.c \
 		   latex.c \
+		   latex_escape.c \
 		   libdiff.c \
 		   library.c \
 		   main.c \
 		   nroff.c \
+		   nroff_escape.c \
 		   odt.c \
 		   smartypants.c \
+		   template.c \
 		   term.c \
 		   tests.c \
 		   tree.c \
@@ -113,8 +121,20 @@
 THUMBS		 = screen-mandoc.thumb.jpg \
 		   screen-groff.thumb.jpg \
 		   screen-term.thumb.jpg
-VALGRINDS	!= for f in `find regress -name \*.md` ; do echo `dirname $$f`/`basename $$f .md`.valgrind ; done
-VALGRINDDIFFS	!= for f in `find regress/diff -name \*.old.md` ; do echo `dirname $$f`/`basename $$f .old.md`.diff-valgrind ; done
+CFLAGS		+= -DVERSION=\"$(VERSION)\"
+# Hack around broken Mac OS X nested sandboxes.
+# If SANDBOX_INIT_ERROR_IGNORE is set to "always", errors from
+# sandbox_init() are ignored.  If set to anything else, the user must
+# also set SANDBOX_INIT_ERROR_IGNORE in their environment to ignore
+# failure.
+# Has no effect unless HAVE_SANDBOX_INIT is defined.
+.ifdef SANDBOX_INIT_ERROR_IGNORE
+.if $(SANDBOX_INIT_ERROR_IGNORE) == "always"
+CFLAGS		+= -DSANDBOX_INIT_ERROR_IGNORE=2
+.else
+CFLAGS		+= -DSANDBOX_INIT_ERROR_IGNORE=1
+.endif
+.endif
 # Because the objects will be compiled into a shared library:
 CFLAGS		+= -fPIC
 # To avoid exporting internal functions (lowdown.h has default visibility).
@@ -135,49 +155,10 @@
 REGRESS_ARGS	+= "--parse-no-cmark"
 REGRESS_ARGS	+= "--parse-no-deflists"
 
-VALGRIND_ARGS	 = -q --leak-check=full --leak-resolution=high --show-reachable=yes
+REGRESS_ENV	 = LC_ALL=en_US.UTF-8
 
 all: bins lowdown.pc liblowdown.so
 bins: lowdown lowdown-diff
-
-valgrind: $(VALGRINDS) $(VALGRINDDIFFS)
-	@exit=0 ; \
-	for f in $(VALGRINDS) ; do \
-		if [ -s $$f ]; then \
-			echo `dirname $$f`/`basename $$f .valgrind`.md ; \
-			cat $$f ; \
-			exit=1 ; \
-		fi ; \
-	done ; \
-	for f in $(VALGRINDDIFFS) ; do \
-		if [ -s $$f ]; then \
-			echo `dirname $$f`/`basename $$f .diff-valgrind`.old.md ; \
-			cat $$f ; \
-			exit=1 ; \
-		fi ; \
-	done ; \
-	exit $$exit
-
-$(VALGRINDS) $(VALGRINDDIFFS): bins
-
-.old.md.diff-valgrind:
-	@rm -f $@
-	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tfodt $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
-	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -thtml $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
-	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tms $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
-	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tman $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
-	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tterm $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
-	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tgemini $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
-
-.md.valgrind:
-	@rm -f $@
-	valgrind $(VALGRIND_ARGS) ./lowdown -s -tfodt $< >/dev/null 2>>$@
-	valgrind $(VALGRIND_ARGS) ./lowdown -s -thtml $< >/dev/null 2>>$@
-	valgrind $(VALGRIND_ARGS) ./lowdown -s -tms $< >/dev/null 2>>$@
-	valgrind $(VALGRIND_ARGS) ./lowdown -s -tman $< >/dev/null 2>>$@
-	valgrind $(VALGRIND_ARGS) ./lowdown -s -tterm $< >/dev/null 2>>$@
-	valgrind $(VALGRIND_ARGS) ./lowdown -s -tgemini $< >/dev/null 2>>$@
-	valgrind $(VALGRIND_ARGS) ./lowdown -s -tlatex $< >/dev/null 2>>$@
 
 www: all $(HTMLS) $(PDFS) $(THUMBS) lowdown.tar.gz lowdown.tar.gz.sha512
 
@@ -215,8 +196,16 @@
 	mkdir -p $(DESTDIR)$(BINDIR)
 	mkdir -p $(DESTDIR)$(MANDIR)/man1
 	mkdir -p $(DESTDIR)$(MANDIR)/man5
+	mkdir -p $(DESTDIR)$(SHAREDIR)/lowdown/html
+	mkdir -p $(DESTDIR)$(SHAREDIR)/lowdown/latex
+	mkdir -p $(DESTDIR)$(SHAREDIR)/lowdown/man
+	mkdir -p $(DESTDIR)$(SHAREDIR)/lowdown/ms
 	mkdir -p $(DESTDIR)$(SHAREDIR)/lowdown/odt
-	$(INSTALL_DATA) share/odt/styles.xml $(DESTDIR)$(SHAREDIR)/lowdown/odt
+	$(INSTALL_DATA) share/html/* $(DESTDIR)$(SHAREDIR)/lowdown/html
+	$(INSTALL_DATA) share/latex/* $(DESTDIR)$(SHAREDIR)/lowdown/latex
+	$(INSTALL_DATA) share/man/* $(DESTDIR)$(SHAREDIR)/lowdown/man
+	$(INSTALL_DATA) share/ms/* $(DESTDIR)$(SHAREDIR)/lowdown/ms
+	$(INSTALL_DATA) share/odt/* $(DESTDIR)$(SHAREDIR)/lowdown/odt
 	$(INSTALL_PROGRAM) lowdown $(DESTDIR)$(BINDIR)
 	$(INSTALL_PROGRAM) lowdown-diff $(DESTDIR)$(BINDIR)
 	for f in $(MAN1S) $(MAN5S) ; do \
@@ -284,7 +273,7 @@
 index.html README.html: template.xml
 
 .md.pdf:
-	./lowdown --nroff-no-numbered -s -tms $< | \
+	./lowdown --roff-no-numbered -s -tms $< | \
 		pdfroff -i -mspdf -t -k > $@
 
 index.latex.pdf: index.md $(THUMBS)
@@ -293,11 +282,11 @@
 	pdflatex index.latex.latex
 
 index.mandoc.pdf: index.md
-	./lowdown --nroff-no-numbered -s -tman index.md | \
+	./lowdown --roff-no-numbered -s -tman index.md | \
 		mandoc -Tpdf > $@
 
 index.nroff.pdf: index.md
-	./lowdown --nroff-no-numbered -s -tms index.md | \
+	./lowdown --roff-no-numbered -s -tms index.md | \
 		pdfroff -i -mspdf -t -k > $@
 
 .xml.html:
@@ -316,7 +305,7 @@
 	./lowdown-diff -s diff.old.md diff.md >$@
 
 diff.diff.pdf: diff.md diff.old.md lowdown-diff
-	./lowdown-diff --nroff-no-numbered -s -tms diff.old.md diff.md | \
+	./lowdown-diff --roff-no-numbered -s -tms diff.old.md diff.md | \
 		pdfroff -i -mspdf -t -k > $@
 
 $(HTMLS): versions.xml lowdown
@@ -342,17 +331,30 @@
 lowdown.tar.gz:
 	mkdir -p .dist/lowdown-$(VERSION)/
 	mkdir -p .dist/lowdown-$(VERSION)/man
+	mkdir -p .dist/lowdown-$(VERSION)/share/html
+	mkdir -p .dist/lowdown-$(VERSION)/share/latex
+	mkdir -p .dist/lowdown-$(VERSION)/share/man
+	mkdir -p .dist/lowdown-$(VERSION)/share/ms
 	mkdir -p .dist/lowdown-$(VERSION)/share/odt
 	mkdir -p .dist/lowdown-$(VERSION)/regress/html
+	mkdir -p .dist/lowdown-$(VERSION)/regress/metadata
 	mkdir -p .dist/lowdown-$(VERSION)/regress/original
 	mkdir -p .dist/lowdown-$(VERSION)/regress/standalone
-	mkdir -p .dist/lowdown-$(VERSION)/regress/metadata
+	mkdir -p .dist/lowdown-$(VERSION)/regress/template
 	mkdir -p .dist/lowdown-$(VERSION)/regress/diff
 	$(INSTALL) -m 0644 $(HEADERS) .dist/lowdown-$(VERSION)
 	$(INSTALL) -m 0644 $(SOURCES) .dist/lowdown-$(VERSION)
+	$(INSTALL) -m 0644 share/html/* .dist/lowdown-$(VERSION)/share/html
+	$(INSTALL) -m 0644 share/latex/* .dist/lowdown-$(VERSION)/share/latex
+	$(INSTALL) -m 0644 share/man/* .dist/lowdown-$(VERSION)/share/man
+	$(INSTALL) -m 0644 share/ms/* .dist/lowdown-$(VERSION)/share/ms
 	$(INSTALL) -m 0644 share/odt/* .dist/lowdown-$(VERSION)/share/odt
 	$(INSTALL) -m 0644 lowdown.in.pc Makefile LICENSE.md .dist/lowdown-$(VERSION)
 	$(INSTALL) -m 0644 man/*.1 man/*.3 man/*.5 .dist/lowdown-$(VERSION)/man
 	$(INSTALL) -m 0755 configure .dist/lowdown-$(VERSION)
 	$(INSTALL) -m 644 regress/original/* .dist/lowdown-$(VERSION)/regress/original
 	$(INSTALL) -m 644 regress/*.* .dist/lowdown-$(VERSION)/regress
+	$(INSTALL) -m 644 regress/diff/* .dist/lowdown-$(VERSION)/regress/diff
+	$(INSTALL) -m 644 regress/html/* .dist/lowdown-$(VERSION)/regress/html
+	$(INSTALL) -m 644 regress/metadata/* .dist/lowdown-$(VERSION)/regress/metadata
+	$(INSTALL) -m 644 regress/standalone/* .dist/lowdown-$(VERSION)/regress/standalone

=== debian/changelog ===
lowdown (2.0.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Faidon Liambotis <paravoid@debian.org>  Mon, 03 Mar 2025 11:23:55 +0200

lowdown (2.0.2-1) experimental; urgency=medium

  * New upstream release.
    - SONAME was bumped due to ABI changes, reflect this at the packaging
      level by renaming the library package to liblowdown2.
  * Build-Depend and set MAKE to "bmake", as incompatibilities with GNU Make
    have been introduced in the upstream Makefile that are here to stay (see
    upstream #155).
  * Ship default templates under /usr/share/doc/lowdown/examples. Per upstream
    #156 these are not being used at runtime.

 -- Faidon Liambotis <paravoid@debian.org>  Mon, 17 Feb 2025 21:11:55 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Maintainer: Faidon Liambotis <paravoid@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
+ bmake,
  libbsd-dev,
  libmd-dev,
  pkgconf,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: text
 Homepage: https://kristaps.bsd.lv/lowdown/
 Vcs-Browser: https://salsa.debian.org/debian/lowdown
@@ -40,7 +41,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: liblowdown1 (= ${binary:Version}), ${misc:Depends}
+Depends: liblowdown2 (= ${binary:Version}), ${misc:Depends}
 Description: Simple markdown translator (development files)
  Lowdown is a Markdown translator producing HTML5, roff documents in the ms and
  man formats, LaTeX, gemini, and terminal output.
@@ -62,7 +63,7 @@
  .
  This package contains development libraries, header files, and manpages.
 
-Package: liblowdown1
+Package: liblowdown2
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,9 @@
 #export DH_VERBOSE = 1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+# Upstream uses and tests with BSD Make, so prefer it over GNU
+export MAKE = /usr/bin/bmake
 
 # Use libbsd for a system copy of the BSD functions, instead of upstream's
 # embedded compats.c coming from the oconfigure project.
@@ -31,12 +34,12 @@
 
 override_dh_auto_install:
 	# make install only installs the main binary, not the library
-	make install DESTDIR=debian/tmp
-	make install_static DESTDIR=debian/tmp
-	make install_shared DESTDIR=debian/tmp
+	$(MAKE) install DESTDIR=debian/tmp
+	$(MAKE) install_static DESTDIR=debian/tmp
+	$(MAKE) install_shared DESTDIR=debian/tmp
 
 override_dh_auto_test:
-	make regress
+	$(MAKE) regress
 
 override_dh_auto_clean:
 	echo > Makefile.configure

## lowdown 2.0.4

=== Makefile ===
--- 
+++ 
@@ -10,10 +10,13 @@
 # while libraries have well-defined semantics of semver change, programs
 # do not.  Let the library guide our versioning until a better way is
 # thought out.
-VERSION		 = 2.0.2
+VERSION		 = 2.0.4
+
 # This is the major number of VERSION.  It might later become
 # MAJOR.MINOR, if the library moves a lot.
 LIBVER		 = 2
+
+# The usual variables.
 OBJS		 = autolink.o \
 		   buffer.o \
 		   diff.o \
@@ -122,6 +125,7 @@
 		   screen-groff.thumb.jpg \
 		   screen-term.thumb.jpg
 CFLAGS		+= -DVERSION=\"$(VERSION)\"
+
 # Hack around broken Mac OS X nested sandboxes.
 # If SANDBOX_INIT_ERROR_IGNORE is set to "always", errors from
 # sandbox_init() are ignored.  If set to anything else, the user must
@@ -135,6 +139,34 @@
 CFLAGS		+= -DSANDBOX_INIT_ERROR_IGNORE=1
 .endif
 .endif
+
+# Names of shared and static libraries.
+LIB_SO		 = liblowdown.$(LINKER_SOSUFFIX)
+LIB_ST		 = liblowdown.a
+
+# On some Linux distributions, the preferred method of distributing
+# binaries is with dynamically-linked libraries.  Use the LINK_METHOD
+# variable set with ./configure to determine whether to use static
+# (default) or dynamic linking.
+# The dynamic version will also need the compats when building the main
+# object.
+LIB_LOWDOWN 	 = $(LIB_ST)
+MAIN_OBJS	 =
+.ifdef LINK_METHOD
+.if $(LINK_METHOD) == "shared"
+LIB_LOWDOWN 	 = $(LIB_SO)
+MAIN_OBJS	 = $(COMPAT_OBJS)
+.endif
+.endif
+
+# Mac OS X and other Unix systems use different conventions for
+# indicating shared library versions.
+.if $(LINKER_SOSUFFIX) == "dylib"
+LIB_SOVER	 = liblowdown.$(LIBVER).$(LINKER_SOSUFFIX)
+.else
+LIB_SOVER	 = liblowdown.$(LINKER_SOSUFFIX).$(LIBVER)
+.endif
+
 # Because the objects will be compiled into a shared library:
 CFLAGS		+= -fPIC
 # To avoid exporting internal functions (lowdown.h has default visibility).
@@ -157,7 +189,7 @@
 
 REGRESS_ENV	 = LC_ALL=en_US.UTF-8
 
-all: bins lowdown.pc liblowdown.so
+all: bins lowdown.pc $(LIB_SO)
 bins: lowdown lowdown-diff
 
 www: all $(HTMLS) $(PDFS) $(THUMBS) lowdown.tar.gz lowdown.tar.gz.sha512
@@ -170,18 +202,20 @@
 	$(INSTALL) -m 0444 lowdown.tar.gz $(WWWDIR)/snapshots
 	$(INSTALL) -m 0444 lowdown.tar.gz.sha512 $(WWWDIR)/snapshots
 
-lowdown: liblowdown.a main.o
-	$(CC) -o $@ main.o liblowdown.a $(LDFLAGS) $(LDADD_MD5) -lm $(LDADD)
+lowdown: $(LIB_LOWDOWN) $(MAIN_OBJS) main.o
+	$(CC) -o $@ main.o $(MAIN_OBJS) $(LIB_LOWDOWN) $(LDFLAGS) $(LDADD_MD5) -lm $(LDADD)
 
 lowdown-diff: lowdown
 	ln -f lowdown lowdown-diff
 
-liblowdown.a: $(OBJS) $(COMPAT_OBJS)
+$(LIB_ST): $(OBJS) $(COMPAT_OBJS)
 	$(AR) rs $@ $(OBJS) $(COMPAT_OBJS)
 
-liblowdown.so: $(OBJS) $(COMPAT_OBJS)
-	$(CC) -shared -o $@.$(LIBVER) $(OBJS) $(COMPAT_OBJS) $(LDFLAGS) $(LDADD_MD5) -lm -Wl,${LINKER_SONAME},$@.$(LIBVER) $(LDLIBS)
-	ln -sf $@.$(LIBVER) $@
+$(LIB_SO): $(OBJS) $(COMPAT_OBJS)
+	$(CC) $(LINKER_SOFLAG) -o $(LIB_SOVER) $(OBJS) $(COMPAT_OBJS) \
+		$(LDFLAGS) $(LDADD_MD5) -lm \
+		-Wl,${LINKER_SONAME},$(LIB_SOVER) $(LDLIBS)
+	ln -sf $(LIB_SOVER) $@
 
 uninstall:
 	rm -rf $(SHAREDIR)/lowdown
@@ -236,17 +270,17 @@
 	done
 
 uninstall_shared: uninstall_lib_common
-	rm -f $(LIBDIR)/liblowdown.so.$(LIBVER) $(LIBDIR)/liblowdown.so
-
-install_shared: liblowdown.so install_lib_common
-	$(INSTALL_LIB) liblowdown.so.$(LIBVER) $(DESTDIR)$(LIBDIR)
-	( cd $(DESTDIR)$(LIBDIR) && ln -sf liblowdown.so.$(LIBVER) liblowdown.so )
+	rm -f $(LIBDIR)/$(LIB_SOVER) $(LIBDIR)/$(LIB_SO)
+
+install_shared: $(LIB_SO) install_lib_common
+	$(INSTALL_LIB) $(LIB_SOVER) $(DESTDIR)$(LIBDIR)
+	( cd $(DESTDIR)$(LIBDIR) && ln -sf $(LIB_SOVER) $(LIB_SO) )
 
 uninstall_static: uninstall_lib_common
-	rm -f $(LIBDIR)/liblowdown.a
-
-install_static: liblowdown.a install_lib_common
-	$(INSTALL_LIB) liblowdown.a $(DESTDIR)$(LIBDIR)
+	rm -f $(LIBDIR)/$(LIB_ST)
+
+install_static: $(LIB_ST) install_lib_common
+	$(INSTALL_LIB) $(LIB_ST) $(DESTDIR)$(LIBDIR)
 
 uninstall_libs: uninstall_shared uninstall_static
 
@@ -346,15 +380,3 @@
 	$(INSTALL) -m 0644 $(SOURCES) .dist/lowdown-$(VERSION)
 	$(INSTALL) -m 0644 share/html/* .dist/lowdown-$(VERSION)/share/html
 	$(INSTALL) -m 0644 share/latex/* .dist/lowdown-$(VERSION)/share/latex
-	$(INSTALL) -m 0644 share/man/* .dist/lowdown-$(VERSION)/share/man
-	$(INSTALL) -m 0644 share/ms/* .dist/lowdown-$(VERSION)/share/ms
-	$(INSTALL) -m 0644 share/odt/* .dist/lowdown-$(VERSION)/share/odt
-	$(INSTALL) -m 0644 lowdown.in.pc Makefile LICENSE.md .dist/lowdown-$(VERSION)
-	$(INSTALL) -m 0644 man/*.1 man/*.3 man/*.5 .dist/lowdown-$(VERSION)/man
-	$(INSTALL) -m 0755 configure .dist/lowdown-$(VERSION)
-	$(INSTALL) -m 644 regress/original/* .dist/lowdown-$(VERSION)/regress/original
-	$(INSTALL) -m 644 regress/*.* .dist/lowdown-$(VERSION)/regress
-	$(INSTALL) -m 644 regress/diff/* .dist/lowdown-$(VERSION)/regress/diff
-	$(INSTALL) -m 644 regress/html/* .dist/lowdown-$(VERSION)/regress/html
-	$(INSTALL) -m 644 regress/metadata/* .dist/lowdown-$(VERSION)/regress/metadata
-	$(INSTALL) -m 644 regress/standalone/* .dist/lowdown-$(VERSION)/regress/standalone

=== debian/changelog ===
lowdown (2.0.4-2) unstable; urgency=medium

  * Add liblowdown-dev -> libbsd-dev, libmd-dev dependencies, as these are
    a) required for static linking and b) required in all cases by pkgconf's
    stricter parser. (Closes: #1126924)
  * Remove Rules-Requires-Root: no (now the default).

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 13 Feb 2026 10:34:28 +0100

lowdown (2.0.4-1) unstable; urgency=medium

  * New upstream release.
    - Update debian/copyright with authors for new compats.c code.
    - Workaround a new oconfigure distclean limitation..
  * Fix a long-standing regression testing issue, where the test suite was
    using en_US.UTF-8 for its locale, which is not part of a minimal Debian
    chroot. Patch the Makefile to use C.UTF-8 instead.
  * Update debian/watch to version 5.
  * Remove Priority: optional; this is now the default.
  * Bump Standards-Version to 4.7.3.

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 02 Jan 2026 16:51:06 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,4 @@
 Source: lowdown
-Priority: optional
 Maintainer: Faidon Liambotis <paravoid@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
@@ -7,12 +6,11 @@
  libbsd-dev,
  libmd-dev,
  pkgconf,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Section: text
 Homepage: https://kristaps.bsd.lv/lowdown/
 Vcs-Browser: https://salsa.debian.org/debian/lowdown
 Vcs-Git: https://salsa.debian.org/debian/lowdown.git
-Rules-Requires-Root: no
 
 Package: lowdown
 Architecture: any
@@ -41,7 +39,11 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: liblowdown2 (= ${binary:Version}), ${misc:Depends}
+Depends:
+ liblowdown2 (= ${binary:Version}),
+ ${misc:Depends},
+ libbsd-dev,
+ libmd-dev,
 Description: Simple markdown translator (development files)
  Lowdown is a Markdown translator producing HTML5, roff documents in the ms and
  man formats, LaTeX, gemini, and terminal output.

=== debian/rules ===
--- 
+++ 
@@ -43,4 +43,7 @@
 
 override_dh_auto_clean:
 	echo > Makefile.configure
+	# an .if makes "make distclean" fail here, even though
+	# LINKER_SOSUFFIX isn't actually used by it
+	echo "LINKER_SOSUFFIX = so" >> Makefile.configure
 	dh_auto_clean

=== debian/tests/control ===
# Test whether the command-line executable works, by passing a well-known
# Markdown file to it.
Test-Command: lowdown LICENSE.md

# Test whether the static library works by compiling and running simple program
Tests: compile-run-static
Depends:
 build-essential,
 pkgconf,
 liblowdown-dev,

# Test whether the shared library works by compiling and running simple program
Tests: compile-run-shared
Depends:
 build-essential,
 pkgconf,
 liblowdown-dev,

=== debian/watch ===
Version: 5
Source: https://kristaps.bsd.lv/lowdown/snapshots/
Matching-Pattern: @PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
